/*
 *
 * Multicast - ein Programm das Befehle wiederholt
 * aka Miacr - Miacr is a command repeater
 * 2002 by Viper_One & Leonidas
 *
 */

#include <iostream>
#include <string>
using namespace std;

// Prototypen
int main(int argc,char* argv[]);
void DisplayLogo();
unsigned short int VerifyInput(string strCheck);
void developer(unsigned short int number);
string CueStrings(string string1, string string2);
void StartProg(string app);
// Ende der Prototypen

int main(int argc,char* argv[])
{
        string StringFirstParam;			// Deklarierung der beiden Strings, die die Parameter beinhalten
	string StringSecondParam;

	argc = argc--;					// Argumentanzahl um 1 verringern, weil erster Parameter der Dateiname ist	
	DisplayLogo();					// Logo mit Version usw.

	if(argc == 0)					// Falls keine Parameter beim Start angegeben
	{
		cout << "Argument eingeben: ";		// Der User wird nach dem ersten Argument gefragt
		cin >> StringFirstParam;		// Input in einen String, schon ausgebessert
	}
	else						// Falls beim start doch Parameter Angegeben wurden
	{
		StringFirstParam = argv[1];		// Diesmal ist der string das erste Argument
	}

	bool RunProg = true;				// Solange dies true ist, luft das Programm
	string LastCommand;				// Der letzte Befehl des Users
	
	while (RunProg == true)				// wenn false, dann wird das Programm beendet
	{
		cout << StringFirstParam << ">";	// Verbesserte Version, jetzt mit String
		cin >> StringSecondParam;		// Verbessert, jetzt auch mit Strings
		
		if (StringSecondParam == "exit")	// Falls das Programm beendet werden soll
		{
			cout << "Quitting!" << endl;
			RunProg = false;		// Die  Pseudo Shell wird verlassen... das Programm auch
		}
		else					// Falls es doch nicht beendet werden soll
		{
			if (StringSecondParam != "last")// Wenn der 2. Parameter NICHT "last" ist ...
			{
							// Und VerifyInput(..) ihn NICHT verarbeitet
				if (VerifyInput(StringSecondParam) == 0)	
				{
							// Wird LastCommand verndert:
					LastCommand = CueStrings(StringFirstParam, StringSecondParam);
							// und das Programm gestartet:
					StartProg(LastCommand);
				}
			}
			else				// Wenn der 2. Parameter doch "last" ist
			{
				StartProg(LastCommand);	// Wird das vorherige Programm mit den gleichen Parametern gestartet
			}
				
		}
	}
	return 0;
}

void DisplayLogo()
{
/* Zeigt die Versionsinformationen an
 */
	const unsigned short int major = 0;		//Hauptversionsnummer
	const unsigned short int minor = 3;		//Unterversion
	const unsigned short int year = 2002;		//Jahr
	const unsigned short int release = 33;		// Release
	const bool isLinux = true;			// Ob Linux u.. oder nicht	

	if (!isLinux)					// Falls das OS nicht Linux ist wird "Multicast" ausgegeben
	{
		cout << "Multicast v" << major << "." << minor << " Release " << release << " " << year << " by Leonidas & Viper_One" << endl;
	}
	else						// in Linux wird "Miacr" ausgegeben
	{
		cout << "Miacr v" << major << "." << minor << " Release " << release << " " << year << " by Leonidas & Viper_One" << endl;
	}
}

unsigned short int VerifyInput(string strCheck)
{
/* Falls das das Input von VerifyInput behandelt wird wird 1 zurckgegeben
 * andernfalls 0
 */

	if (strCheck == "help")			// Falls der User in der PseudoShell help wollte
	{
		cout << "Hilfe ist noch nicht implementiert, sorry." << endl;
		return 1;				// Das Kommando wurde interpretiert also kommt 1 zurck
	}
	if (strCheck == "dev")				// Falls der User aber eine Liste der Entwickler will
	{
		unsigned short int number;
		cout << "About the developers" << endl;
		cout << "Choose one:" << endl;
		cout << "1 - Leonidas" << endl;
		cout << "2 - Viper_One" << endl;
		cout << "3 - thx to..." << endl;
		cout << "0 - Exit" << endl;
		cout << "Number: ";
		cin >> number;
		developer(number);			// Die Einzelbeschreibung der Entwickler
		return 1;				// interpretiert also kommt 1
	}
 	else						// Falls keiner der oberen Vergleiche zutritt:
	{
		return 0;				// nicht interpretiert also 0
	}
}

void developer(unsigned short int number)
{
/* Zeigt die Einzelbeschreibung der Entwickler
 */
	switch(number)
	{
		case 1:					// Marek				
		{
			cout << "Marek Kubica alias Leonidas" << endl;
			cout << endl;
			cout << "Ideen, Bugfixes, Programmierung" << endl;
			cout << "Interessen: Computer, Ski, Fahrrad" << endl;
			cout << "Programmiersprachen: VB, C++, Pascal, HTML" << endl;
			cout << "H\x84ufigster Kommentar: Ohh nein! Das geht schon wieder nicht!" << endl;
			cout << endl;
			cout << "--" << endl;
			cout << "Reden ist Schweigen, Silber ist Gold" << endl;
			cout << endl;
			cout << "Echte Missverst\x84ndnisse vervielf\x84ltigen sich durch Zellteilung. Der Kern des " << endl;
			cout << "Irrtums spaltet sich, und neue Missverst\x84ndnisse entstehen. (Erich K\x84stner)" << endl;
			cout << endl;
			break;
		}
		case 2:					// Marco
		{
			cout << "Marco Haase alias Viper_One" << endl;
			cout << endl;
			cout << "Interessen: Programmierung, Lesen" << endl;
			cout << "Programmiersprachen: C++, HTML" << endl;
			cout << "Hufigster Kommentar: So ein Mist, das funktioniert nie!" << endl;
			cout << endl;
			cout << "--" << endl;
			cout << "Zwei Dinge sind unendlich: Das Universum und die Menschliche Dummheit" << endl;
			cout << "Aber beim Universum ist das noch nicht ganz sicher. (Albert Einstein)" << endl;
			cout << endl;
			break;
		}
		case 3:					// Sonstige Credits
		{
			cout << "Dank an:" << endl;
			cout << "Quellcodes.de" <<endl;
			cout << "programmierer-board.de" << endl;
			cout << "Dirk's Forum: forum.matthias-buchetics.com" << endl;
			cout << "Mozilla - der beste Browser! (Leonidas)" << endl;
			cout << "Internet Explorer - der beste Browser! (Viper_One)" <<endl;
			cout << "GNU/Linux" << endl;
			cout << "GCC/MinGW Team" << endl;
		}
		default:
		{
							// Abbrechen
		}
	}
}

string CueStrings(string string1, string string2)
{
/* Klebt zwei Strings mit einem Leerzeichen dazwischen
 * zusammen und gibt sie aus
 */
	string output = string1 + string(" ") + string2;
	return output;
}

void StartProg(string app)
{
/* Ein externes Programm wird gestartet
 */
	const char* cmd = app.c_str();			// Aus String const char* machen
	system(cmd);					// Startet das Programm
}
